//	Copyright:	 1992 by Apple Computer, Inc., all rights reserved.

#include "mtb.h"

pascal OSErr MyCoverProc (Movie aMovie,  RgnHandle changedRgn,
									long refcon)
{
	CGrafPtr 				mPort;
	GDHandle 				mGD;
	
	GetMovieGWorld (aMovie, &mPort, &mGD);
	DiffRgn (mPort->clipRgn, changedRgn, mPort->clipRgn);
	return noErr;
}

pascal OSErr MyUnCoverProc (Movie aMovie,  RgnHandle changedRgn,
									 long refcon)
{
	CGrafPtr 				mPort, curPort;
	GDHandle 				mGD, curGD;
	
	GetMovieGWorld (aMovie, &mPort, &mGD);
	GetGWorld (&curPort, &curGD);
	SetGWorld (mPort, mGD);	

	InvalRgn (changedRgn);
	UnionRgn (mPort->clipRgn, changedRgn, mPort->clipRgn);
	
	SetGWorld (curPort, curGD);
	return noErr;
}

void InitCoverProcs (WindowPtr aWindow,  Movie aMovie)
{
	RgnHandle 				displayBounds;
	GrafPtr				curPort;
	
	displayBounds = GetMovieDisplayBoundsRgn (aMovie);
	if (displayBounds == nil) return;
	
	GetPort (&curPort);
	SetPort (aWindow);
	ClipRect (&aWindow->portRect);
	DiffRgn (aWindow->clipRgn, displayBounds, aWindow->clipRgn);
	DisposeRgn( displayBounds );
	SetPort (curPort);
	
	SetMovieCoverProcs (aMovie, &MyUnCoverProc, &MyCoverProc, 0);
}
