/*
	bat.h
	bat structures header file for PowerOS
	copyright 1996-1997 by Ben Martz
	all rights reserved world wide

	ANY AND ALL MODIFICATIONS TO THIS SOURCE MUST CREDIT THE ORIGINAL
	AUTHOR, BEN MARTZ (benmartz@ic.net), AND MUST BE GIVEN TO THE AUTHOR
	FOR INTEGRATION INTO THE MAIN PowerOS SOURCE TREE. THANK YOU FOR YOUR
	COOPERATION!
*/

/*
	oops...forgot about the different layouts!
	these are for 603/604
*/
typedef struct {
	unsigned long	bepi : 15;
	unsigned long	rsvd1 : 4;
	unsigned long	bl : 11;
	unsigned long	vs : 1;
	unsigned long	vp : 1;
} BATU_60x;

typedef struct {
	unsigned long	brpn : 15;
	unsigned long	rsvd1 : 10;
	unsigned long	wimg : 4;
	unsigned long	rsvd2 : 1;
	unsigned long	pp : 2;
} BATL_60x;

typedef struct {
	unsigned long	blpi : 15;
	unsigned long	rsvd1 : 10;
	unsigned long	wim : 3;
	unsigned long	ks : 1;
	unsigned long	ku : 1;
	unsigned long	pp : 2;
} BATU_601;

typedef struct {
	unsigned long	pbn : 15;
	unsigned long	rsvd1 : 10;
	unsigned long	v : 1;
	unsigned long	bsm : 6;
} BATL_601;

#define	BAT_BL_128K	0
#define	BAT_BL_256K	1
#define	BAT_BL_512K	3
#define	BAT_BL_1M	7
#define	BAT_BL_2M	31
#define	BAT_BL_4M	63
#define	BAT_BL_8M	127
	/* only the above are valid for the 601 */
#define	BAT_BL_16M	255
#define	BAT_BL_32M	511
#define	BAT_BL_64M	1023
#define	BAT_BL_128M	2047
#define	BAT_BL_256M	4095

#define	BAT_WIMG_W	1	/* write through */
#define	BAT_WIMG_I	2	/* caching inhibited */
#define	BAT_WIMG_M	4	/* memory coherence */
