/*
	debug_console.h
	a header file for PowerOS
	copyright 1996-1997 by Ben Martz
	all rights reserved world wide
	
	ANY AND ALL MODIFICATIONS TO THIS SOURCE MUST CREDIT THE ORIGINAL
	AUTHOR, BEN MARTZ (benmartz@ic.net), AND MUST BE GIVEN TO THE AUTHOR
	FOR INTEGRATION INTO THE MAIN PowerOS SOURCE TREE. THANK YOU FOR YOUR
	COOPERATION!
*/

#ifndef ___DEBUG_CONSOLE___
#define ___DEBUG_CONSOLE___

typedef struct {
	int	width, height;
	int	cols, rows;		/* lowest value is 1 */
	int	xpos, ypos;		/* as absolute pixels */
	int	colpos, rowpos;
	long	forecolor, backcolor;
} ConsolePrivateData, *ConsolePrivatePtr;

void	cinit(void);

void	cputchar(u_char c);

void	cputcharpixel(int offsetH, int offsetV, u_long value);

void	cgotoxy(int x, int y);

long	cgetforecolor(void);
void	csetforecolor(long color);
long	cgetbackcolor(void);
void	csetbackcolor(long color);

int	cgetx(void);
int	cgety(void);
int	cgetxmax(void);
int	cgetymax(void);

void	ctab(void);
void	cnewline(void);

#endif
