/*
        exception_entry.S
	exception handler entries for PowerOS
        copyright 1996-1997 by Ben Martz
        all rights reserved world wide

        ANY AND ALL MODIFICATIONS TO THIS SOURCE MUST CREDIT THE ORIGINAL
        AUTHOR, BEN MARTZ (benmartz@ic.net), AND MUST BE GIVEN TO THE AUTHOR
        FOR INTEGRATION INTO THE MAIN PowerOS SOURCE TREE. THANK YOU FOR YOUR
        COOPERATION!
*/

#include "stdhdr.s"
#include "exception_stub.s"

/*********************************************************************/

	.globl	_SystemReset
_SystemReset:
	ENTER_EXCEPTION;
	b	SystemReset
	.globl	_SystemReset_exit
_SystemReset_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_MachineCheck
_MachineCheck:
	ENTER_EXCEPTION;
	b	MachineCheck
	.globl	_MachineCheck_exit
_MachineCheck_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_DataStorage
_DataStorage:
	ENTER_EXCEPTION;
	b	DataStorage
	.globl	_DataStorage_exit
_DataStorage_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_InstructionStorage
_InstructionStorage:
	ENTER_EXCEPTION;
	b	InstructionStorage
	.globl	_InstructionStorage_exit
_InstructionStorage_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_External
_External:
	ENTER_EXCEPTION;
	b	External
	.globl	_External_exit
_External_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_Alignment
_Alignment:
	ENTER_EXCEPTION;
	b	Alignment
	.globl	_Alignment_exit
_Alignment_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_Program
_Program:
	ENTER_EXCEPTION;
	b	Program
	.globl	_Program_exit
_Program_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_FPUnavailable
_FPUnavailable:
	ENTER_EXCEPTION;
	b	FPUnavailable
	.globl	_FPUnavailable_exit
_FPUnavailable_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_Decrementer
_Decrementer:
	ENTER_EXCEPTION;
	b	Decrementer
	.globl	_Decrementer_exit
_Decrementer_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_IOException
_IOException:
	ENTER_EXCEPTION;
	b	IOException
	.globl	_IOException_exit
_IOException_exit:
	EXIT_EXCEPTION;
	
/*********************************************************************/

	.globl	_SystemCall
_SystemCall:
	ENTER_EXCEPTION;
	b	SystemCall
	.globl	_SystemCall_exit
_SystemCall_exit:
	EXIT_EXCEPTION;
	
/*********************************************************************/

	.globl	_Trace
_Trace:
	ENTER_EXCEPTION;
	b	Trace
	.globl	_Trace_exit
_Trace_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_FPAssist
_FPAssist:
	ENTER_EXCEPTION;
	b	FPAssist
	.globl	_FPAssist_exit
_FPAssist_exit:
	EXIT_EXCEPTION;

/*********************************************************************/

	.globl	_UnknownException
_UnknownException:
	ENTER_EXCEPTION;
	b	UnknownException
	.globl	_UnknownException_exit
_UnknownException_exit:
	EXIT_EXCEPTION;
